#
# Conditional build:
%bcond_without	verbose		# verbose build (V=1)
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace programs
%bcond_without	dkms		# build dkms package

%if 0%{?_pld_builder:1} && %{with kernel} && %{with userspace}
%{error:kernel and userspace cannot be built at the same time on PLD builders}
exit 1
%endif

%if %{without userspace}
%undefine	with_dkms
%endif

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		_duplicate_files_terminate_build	0

%define		rel	6
%define		pname	nvidiabl
Summary:	Linux driver for nVidia display back-lights
Summary(pl.UTF-8):	Sterownik dla Linuksa do podświetlania wyświetlacza dla kart firmy nVidia
Name:		%{pname}%{?_pld_builder:%{?with_kernel:-kernel}}%{_alt_kernel}
Version:	0.87
Release:	%{rel}%{?_pld_builder:%{?with_kernel:@%{_kernel_ver_str}}}
License:	GPL v2+
Group:		Base/Kernel
Source0:	https://github.com/guillaumezin/nvidiabl/archive/v%{version}.tar.gz?/%{pname}-%{version}.tgz
Source1:	modprobe.conf
Patch0:		nvidiabl-dkmsconf.patch
Patch1:		linux-4.0.patch
# Source0-md5:	e9418d3e500172d79680e44ad0f85743
URL:		https://github.com/guillaumezin/nvidiabl
BuildRequires:	rpmbuild(macros) >= 1.701
%{?with_kernel:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:2.6.20.2}}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This driver drives the smartdimmer register found on modern mobile
nVidia graphics adapters such as NV40, NV41, NV43, NV44, NV46, NV47,
NV49, NV4B, C51, G84, G86, G92, G94, G96, GT200 architectures to
adjust the display backlight.

On Apple machines this driver allows more fine-grained brightness
adjustment than the (mbp_nvidia_bl) driver and is generally preferred.

%description -l pl.UTF-8
Ten sterownik steruje rejestrem "smartdimmer" obecnym we współczesnych
mobilnych kartach graficznych firmy nVidia (takich jak architektury
NV40, NV41, NV43, NV44, NV46, NV47, NV49, NV4B, C51, G84, G86, G92,
G94, G96, GT200), służącym do regulacji podświetlenia wyświetlacza.

Na komputerach firmy Apple ten sterownik pozwala na dokładniejsze
ustawianie jasności niż sterownik mbp_nvidia_bl i ogólnie jest
zalecany.

%package -n dkms-%{pname}
Summary:	DKMS-ready driver for nVidia display back-lights
Summary(pl.UTF-8):	Sterownik zgodny z DKMS do podświetlania wyświetlacza dla kart firmy nVidia
License:	GPL v2+
Group:		Base/Kernel
Requires(pre,post):	dkms
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description -n dkms-%{pname}
This package contains a DKMS-ready driver for nVidia laptop display
back-lights.

This driver drives the smartdimmer register found on modern mobile
Nvidia graphics adapters such as NV40, NV41, NV43, NV44, NV46, NV47,
NV49, NV4B, C51, G84, G86, G92, G94, G96, GT200 architectures to
adjust the display backlight.

On Apple machines this driver allows more fine-grained brightness
adjustment than the mbp-nvidia-bl-dkms (mbp_nvidia_bl) driver and is
generally preferred.

%description -n dkms-%{pname} -l pl.UTF-8
Ten pakiet zawiera zgodny z DKMS sterownik do podświetlania
wyświetlacza laptopów z kartą graficzną firmy nVidia.

Ten sterownik steruje rejestrem "smartdimmer" obecnym we współczesnych
mobilnych kartach graficznych firmy nVidia (takich jak architektury
NV40, NV41, NV43, NV44, NV46, NV47, NV49, NV4B, C51, G84, G86, G92,
G94, G96, GT200), służącym do regulacji podświetlenia wyświetlacza.

Na komputerach firmy Apple ten sterownik pozwala na dokładniejsze
ustawianie jasności niż sterownik mbp_nvidia_bl i ogólnie jest
zalecany.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-video-nvidiabl\
Summary:	Linux driver for nVidia display back-lights\
Summary(pl.UTF-8):	Sterownik dla Linuksa do podświetlania wyświetlacza dla kart firmy nVidia\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-video-nvidiabl\
This driver drives the smartdimmer register found on modern mobile\
nVidia graphics adapters such as NV40, NV41, NV43, NV44, NV46, NV47,\
NV49, NV4B, C51, G84, G86, G92, G94, G96, GT200 architectures to\
adjust the display backlight.\
\
On Apple machines this driver allows more fine-grained brightness\
adjustment than the (mbp_nvidia_bl) driver and is generally preferred.\
\
%description -n kernel%{_alt_kernel}-video-nvidiabl -l pl.UTF-8\
Ten sterownik steruje rejestrem "smartdimmer" obecnym we współczesnych\
mobilnych kartach graficznych firmy nVidia (takich jak architektury\
NV40, NV41, NV43, NV44, NV46, NV47, NV49, NV4B, C51, G84, G86, G92,\
G94, G96, GT200), służącym do regulacji podświetlenia wyświetlacza.\
\
Na komputerach firmy Apple ten sterownik pozwala na dokładniejsze\
ustawianie jasności niż sterownik mbp_nvidia_bl i ogólnie jest\
zalecany.\
\
%if %{with kernel}\
%files -n kernel%{_alt_kernel}-video-nvidiabl\
%defattr(644,root,root,755)\
/lib/modules/%{_kernel_ver}/misc/*.ko*\
%config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/%{pname}.conf\
%endif\
\
%post	-n kernel%{_alt_kernel}-video-nvidiabl\
%depmod %{_kernel_ver}\
\
%postun	-n kernel%{_alt_kernel}-video-nvidiabl\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%build_kernel_modules -m nvidiabl\
%install_kernel_modules -D installed -m nvidiabl -d misc\
%{nil}

%{?with_kernel:%{expand:%create_kernel_packages}}

%prep
%setup -qn %{pname}-%{version}
%patch0 -p1
%patch1 -p1

%build
%{?with_kernel:%{expand:%build_kernel_packages}}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/modprobe.d

%if %{with kernel}
cp -p %{SOURCE1} $RPM_BUILD_ROOT/etc/modprobe.d/%{pname}.conf
cp -a installed/* $RPM_BUILD_ROOT
%endif

%if %{with dkms}
install -d $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}
cp -p Makefile *.[ch] $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}
sed -e 's|@pname@|%{pname}|g' -e 's|@MODVERSION@|%{version}-%{rel}|g' \
	dkms.conf > $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}/dkms.conf
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n dkms-%{pname}
%{_sbindir}/dkms add -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade && \
%{_sbindir}/dkms build -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade && \
%{_sbindir}/dkms install -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade || :

%preun -n dkms-%{pname}
%{_sbindir}/dkms remove -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade --all || :

%if %{with dkms}
%files -n dkms-%{pname}
%defattr(644,root,root,755)
%{_usrsrc}/%{pname}-%{version}-%{rel}
%endif
%changelog
* Fri Jan 27 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nvidiabl.git;a=log;h=auto/th/nvidiabl-0.87-6

* Sun Apr 19 2015 Jan Rękorajski <baggins@pld-linux.org> f849b58
- fix building with linux 4.0
- rel 6

* Sun Apr 12 2015 Jan Rękorajski <baggins@pld-linux.org> eeb553e
- fix release

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> 8c71422
- x32 rebuild
- release 5 (by relup.sh)

* Sun Feb 08 2015 Jan Rękorajski <baggins@pld-linux.org> 558c261
- that's how you separate userspace and kernel, is copy-pasting a few
  lines from template so hard, glen?
- rel 4

* Wed Feb 04 2015 Elan Ruusamäe <glen@delfi.ee> 8d87e44
- add kernel bcond

* Tue Feb 03 2015 Elan Ruusamäe <glen@delfi.ee> 5f8872f
- wtf you just disable dkms completely!?, added it back. not tested with your "kernel" framework!

* Mon Feb 02 2015 Jan Rękorajski <baggins@pld-linux.org> f994bcd
- disable dkms bcond, whoever wants it wrap it with userspace bcond
- rel 3

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> fb81d56
- rel 2

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> d45709a
- updated kernel modules build system

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> 0169746
- drop non-dist kernel support

* Sat May 10 2014 Jakub Bogusz <qboosh@pld-linux.org> 48c5f17
- pl

* Wed Apr 30 2014 Jan Palus <atler@pld-linux.org> 5184f92
- up to 0.87

* Mon Feb 24 2014 Elan Ruusamäe <glen@delfi.ee> efe3efe
- up to 0.85, some new PCI_IDs

* Mon Feb 24 2014 Elan Ruusamäe <glen@delfi.ee> b4196c5
- enable dkms, verbose bconds

* Mon Oct 28 2013 Jan Rękorajski <baggins@pld-linux.org> 0406611
- switch to macro driven module build for multiple kernel versions
- rel 29

* Mon Oct 07 2013 Jan Rękorajski <baggins@pld-linux.org> 83a43a7
- rebuild for kernel-3.10.15-1
- release 28 (by relup.sh)

* Wed Oct 02 2013 Jan Rękorajski <baggins@pld-linux.org> a89e24c
- rebuild for kernel-3.10.14-1
- release 27 (by relup.sh)

* Fri Sep 27 2013 Jan Rękorajski <baggins@pld-linux.org> e9d3750
- rebuild for kernel-3.10.13-1
- release 26 (by relup.sh)

* Sun Sep 15 2013 Jan Rękorajski <baggins@pld-linux.org> c08a8f8
- rebuild for kernel-3.10.12-1
- release 25 (by relup.sh)

* Tue Sep 10 2013 Jan Rękorajski <baggins@pld-linux.org> 4b3928a
- rebuild for kernel-3.10.11-1
- release 24 (by relup.sh)

